﻿using Oracle.ManagedDataAccess.Client;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration;
using System.Data;
using System.IO;
using System.Linq;
using System.Web;
using System.Web.Http.Results;

namespace SYNC_Telephony.Database
{
    public class DB
    {
        [DataObjectMethod(DataObjectMethodType.Select)]
        public  List<Models.MainData.INDB_PNR_MASTER> GET_INDB_PNR_MASTER()
        {
            List<Models.MainData.INDB_PNR_MASTER> lst_INDB_PNR_MASTER = new List<Models.MainData.INDB_PNR_MASTER>();
            string sSQLQuery = File.ReadAllText(AppDomain.CurrentDomain.BaseDirectory + "Database\\GET_INDB_PNR_MASTER.txt");

            OracleConnection oracon = new OracleConnection(Properties.Settings.Default.DBCon);
            try
            {
                oracon.Open();
                OracleCommand oracmd = oracon.CreateCommand();
                //oracmd.AddRowid = true;
                oracmd.CommandText = sSQLQuery;
                OracleDataReader or = oracmd.ExecuteReader();
                while (or.Read())
                {
                    lst_INDB_PNR_MASTER.Add(new Models.MainData.INDB_PNR_MASTER(
                   
                        or["PHONENUMBER"].ToString(),
                        or["PNR_TYPE"].ToString(),
                        or["pnr_state"].ToString(),
                        or["pnr_group"].ToString(),
                        or["pnr_group_range"].ToString(),
                        or["pnr_group_range_titel"].ToString(),
                        or["coupled_phonenumber"].ToString(),
                        or["manual_reserved_state"].ToString(),
                        or["manual_reserved_end"].ToString(),
                        or["manual_reserved_titel"].ToString(),
                        or["user_titel"].ToString(),
                        or["user_description"].ToString(),
                        or["user_go_ma_id"].ToString(),
                        or["user_source_sys_titel"].ToString()
                        )
                    );



                    //lst_INDB_PNR_MASTER.Add(new Models.MainData.INDB_PNR_MASTER()
                    //{
                    //    PHONENUMBER = or["PHONENUMBER"].ToString(),
                    //    PNR_TYP = or["PNR_TYPE"].ToString(),
                    //    PNR_STATE = or["pnr_state"].ToString(),
                    //    PNR_GROUP = or["pnr_group"].ToString(),
                    //    PNR_GROUP_RANGE = or["pnr_group_range"].ToString(),
                    //    PNR_GROUP_RANGE_TITLE = or["pnr_group_range_titel"].ToString(),
                    //    COUPLED_PHONENUMBER = or["coupled_phonenumber"].ToString(),
                    //    MANUAL_RESERVED_STATE = or["manual_reserved_state"].ToString(),
                    //    MANUAL_RESERVED_END = or["manual_reserved_end"].ToString(),
                    //    MANUAL_RESERVED_TITLE = or["manual_reserved_titel"].ToString(),
                    //    USER_TITLE = or["user_titel"].ToString(),
                    //    USER_DESCRIPTION = or["user_description"].ToString(),
                    //    USER_GO_MA_ID = or["user_go_ma_id"].ToString(),
                    //    USER_SOURCE_SYS_TITLE = or["user_source_sys_titel"].ToString()
                    //});
                }
                or.Dispose();
                oracmd.Dispose();
            }
            catch (Exception exp)
            {
                //ms.cDebugLog.Log("Error in GET_INDB_PNR_MASTER: " + exp.Message + " StackTrace: " + exp.StackTrace, Convert.ToBoolean(ConfigurationManager.AppSettings["Debuglog"]), "Database");
            }
            finally
            {
                oracon.Close();
            }

            //return new JsonResult { Data = (List<Models.MainData.INDB_PNR_MASTER>)lst_INDB_PNR_MASTER, MaxJsonLength = Int32.MaxValue };
            return (List < Models.MainData.INDB_PNR_MASTER > )lst_INDB_PNR_MASTER;
        }
        public DataTable ReadDataToDataTable(int iStart, int iEnd)
        {
            DataTable schematable = null;
            DataTable dt = null;
            OracleCommand oracmd;
            OracleDataReader oradr = null;
            OracleConnection oracon = null;
            long iCount = 0;

            string sSQLQuery = File.ReadAllText(AppDomain.CurrentDomain.BaseDirectory + "Database\\GET_INDB_PNR_MASTER.txt");

            try
            {
                oracon = new OracleConnection(Properties.Settings.Default.DBCon);
                oracon.Open();
                oracmd = oracon.CreateCommand();
                oracmd.CommandText = sSQLQuery;

                oradr = oracmd.ExecuteReader(CommandBehavior.CloseConnection);
                schematable = oradr.GetSchemaTable();
                dt = new DataTable();

                for (int i = 0; i <= schematable.Rows.Count - 1; i++)
                {
                    DataRow dRow = schematable.Rows[i];
                    DataColumn column = new DataColumn();
                    column.DataType = System.Type.GetType(dRow["DataType"].ToString());
                    column.AllowDBNull = (dRow["AllowDBNull"].ToString() == "True" ? true : false);
                    column.ColumnName = dRow["ColumnName"].ToString();
                    column.Caption = dRow["ColumnName"].ToString();

                    dt.Columns.Add(column);
                    //More DataTable property can be added as required.
                }
                if (iStart == 0) iStart = 1;
                if (iEnd == 0) iEnd = 1;
                iCount = 1;


                while (oradr.Read())
                {

                    if (iCount >= iStart && iCount <= iEnd)
                    {
                        DataRow dRow = dt.NewRow();
                        for (int i = 0; i <= oradr.FieldCount - 1; i++)
                        {
                            dRow[i] = oradr.GetValue(i);
                        }
                        dt.Rows.Add(dRow);
                    }
                    else if (iCount > iEnd)
                    {
                        break;
                    }
                    iCount = iCount + 1;
                }
                oradr.Dispose();
                oracmd.Dispose();
            }
            catch (Exception exp)
            {
                //ms.cDebugLog.Log("Error in GET_INDB_PNR_MASTER: " + exp.Message + " StackTrace: " + exp.StackTrace, Convert.ToBoolean(ConfigurationManager.AppSettings["Debuglog"]), "Database");
            }
            finally
            {
                oracon.Close();
            }
            return dt;
        }

    }
}



